
Ruby - Bug #506

ObjectSpace.each_object Segmentation fault

08/27/2008 07:21 PM - mame (Yusuke Endoh)

Status: Closed   

Priority: Normal   

Assignee: mame (Yusuke Endoh)   

Target version:    

ruby -v:  Backport:  

Description

=begin

遠藤です。

2008/08/26 23:37 fujidig fuji.rosen@gmail.com:

Ruby 1.9.0-4 の irb で ObjectSpace.each_object(String){|s| s.dup } を

実行すると SEGV します。

$ irb-1.9.0-4

irb(main):001:0> ObjectSpace.each_object(String){|s| s.dup }

(irb):1: [BUG] Segmentation fault

ruby 1.9.0 (2008-08-26 revision 18849) [i686-linux]

(snip)

 ご報告ありがとうございます。

おそらく以下のパッチで直ると思います。

Index: string.c

--- string.c (revision 18880)

+++ string.c (working copy)

@@ -669,10 +669,9 @@

else {

RSTRING(str)->as.heap.aux.capa = RSTRING(str2)->as.heap.aux.capa;

}

RSTRING(str2)->as.heap.ptr = 0; /* abandon str2 */

RSTRING(str2)->as.heap.len = 0;

RSTRING(str2)->as.heap.aux.capa = 0;

STR_UNSET_NOCAPA(str2);

STR_SET_EMBED(str2); /* abandon str2 */

RSTRING_PTR(str2)[0] = 0;

STR_SET_EMBED_LEN(str2, 0);

rb_enc_associate(str, enc);

ENC_CODERANGE_SET(str, cr);

}

--

Yusuke ENDOH mame@tsg.ne.jp

=end

History

#1 - 09/03/2008 07:01 PM - ko1 (Koichi Sasada)

- Assignee set to mame (Yusuke Endoh)

=begin

=end
#2 - 09/07/2008 10:13 AM - matz (Yukihiro Matsumoto)

- Status changed from Open to Closed

=begin

=end
